'''
    RemoveDups is a program to remove duplicate polygons to avoid bad import data
    Copyright (C) 2010 Tim Sheerman-Chase

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 or version 3 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
'''

def WriteOsm06(nodes, ways, relations, filename):
	fi = open(filename,"wt")
	fi.write("<?xml version='1.0' encoding='UTF-8'?>\n")
	fi.write("<osm version='0.6' generator='WriteOsm06.py'>\n")
	for nodeId in nodes.keys():
		#print nodes[nodeId]
		node = nodes[nodeId]
		fi.write("<node ")
		for key in node.keys():
			if key == 'tags': continue
			fi.write(key+"='"+str(node[key])+"' ")
		if 'tags' in node and len(node['tags'])>0:
			fi.write(">\n")
			for tagKey in node['tags'].keys():
				fi.write("    <tag k='"+str(tagKey)+"' v='"+str(node['tags'][tagKey])+"' />\n")
			fi.write("</node>\n")

		else:
			fi.write(" />\n")
	
	for wayId in ways.keys():
		way = ways[wayId]
		fi.write("<way ")
		for key in way.keys():
			if key == 'tags': continue
			if key == 'nd': continue
			fi.write(key+"='"+str(way[key])+"' ")
		fi.write(">\n")
		if 'nd' in way:
			for n in way['nd']:
				fi.write("    <nd ref='"+str(n)+"' />\n")
		if 'tags' in way:
			for tagKey in way['tags'].keys():
				fi.write("    <tag k='"+str(tagKey)+"' v='"+str(way['tags'][tagKey])+"' />\n")
		fi.write("</way>\n")


	for relationId in relations.keys():
		relation = relations[relationId]
		fi.write("<relation ")
		for key in way.keys():
			if key == 'tags': continue
			if key == 'nodeMembers': continue
			if key == 'wayMembers': continue
			if key == 'relationMembers': continue
			fi.write(key+"='"+str(way[key])+"' ")
		fi.write(">\n")
		if 'tags' in way:
			for tagKey in way['tags'].keys():
				fi.write("    <tag k='"+str(tagKey)+"' v='"+str(way['tags'][tagKey])+"' />\n")

		for member in relation['nodeMembers']:
			fi.write("    <member type='node' ref='"+member[1]+"' role='"+member[0]+"' />\n")
		for member in relation['wayMembers']:
			fi.write("    <member type='way' ref='"+member[1]+"' role='"+member[0]+"' />\n")			
		for member in relation['relationMembers']:
			fi.write("    <member type='relation' ref='"+member[1]+"' role='"+member[0]+"' />\n")
		fi.write("</relation>\n")

	fi.write("</osm>\n")
'''
  <relation id='572423' timestamp='2010-04-23T14:17:59Z' uid='93583' user='Mezzanine' visible='true' version='1' changeset='4503970'>
    <member type='way' ref='27366794' role='outer' />
    <member type='way' ref='23185669' role='inner' />
    <member type='way' ref='23185668' role='inner' />
    <tag k='landuse' v='grass' />
    <tag k='type' v='multipolygon' />
  </relation>
'''
	

